library Cgate_core;

uses
  WinApi.Windows,
  System.SysUtils,
  Cgate_functions in 'Cgate_functions.pas',
  Cgate_classes in 'Cgate_classes.pas',
  Cgate_types in 'Cgate_types.pas',
  cgate in 'cgate.pas';

//--- Detach Dll
procedure Process_Detach;
begin
  if (Assigned(CgCore)) then FreeANdNil(CgCore);
end;

//--- Connect to router
function PlazaConnect(lpP2Set: TP2Set): PAnsiChar; stdcall; export;
begin
  if (Assigned(CgCore)) then
  begin
    result:= CgCore.Connect(lpP2Set);
  end else result:= PAnsiChar('Error: Cgate core class not created!');
end;

//--- Disconnect router
function PlazaDisconnect(): boolean; stdcall; export;
begin
  Result:= CgCore.Disconnect();
end;

//--- Create cgate core ---
procedure Process_Attach;
begin
  if (not Assigned(CgCore)) then
    CgCore:= TCgate_core.Create();
end;

//--- Main ----
procedure DllMain(Reason: Integer);
begin
  case Reason of
    DLL_PROCESS_ATTACH: Process_Attach();
    DLL_PROCESS_DETACH: Process_Detach();
  end;
end;

//--- Get trade instruments ---
function GetInstruments(var aData: Pointer): integer; stdcall; export;
begin
  Result:= CgCore.GetSymbols(aData);
end;

{$R *.res}

exports
  PlazaConnect,
  PlazaDisconnect,
  GetInstruments;


begin
  DllProc:= @DllMain;
  DllMain(DLL_PROCESS_ATTACH);
end.
