unit Cgate_functions;

interface

uses
  WinApi.Windows, System.SysUtils, Winapi.WinSvc, System.classes, cgate_types,
  System.AnsiStrings, System.Win.Registry, cgate;

//--- Functions declaration
  function GetCgDllFullPath(const regKey: string; const RegValue: string): string;
  function GetCgService(const Machine: PWideChar; const sName: PWideChar): boolean;
  function LoadCgLib(const Name: string; var aHandle: THandle): boolean;
  function GetListenerName(const input: string): string;

implementation

//--- Get cgate lib fullpath
function GetCgDllFullPath;
var
 Reg: TRegistry;
 k: integer;
begin
  result:= '';
  Reg:= TRegistry.Create;
  try
    Reg.RootKey:= HKEY_LOCAL_MACHINE;
    if(Reg.OpenKeyReadOnly(regKey)) then
    begin
      result:= Reg.ReadString(regValue);
      if(result <> '') then
      begin
        k:= Pos('bin', result);
        if (k = 0) then result:= result + 'bin\';
      end;
    end;
  finally
    Reg.Free;
  end;
end;

//--- Check for service running
function GetCgService;
var
  h_manager, h_service: SC_Handle;
  lpServiceStatus: SERVICE_STATUS;
begin
  result:= false;
//--- Open service manager
  h_manager:= OpenSCManager(Machine, nil, SC_MANAGER_CONNECT);
  try
    if (h_manager > 0) then
    begin
//--- Open service with status
      h_service:= OpenService(h_manager, sName, SERVICE_QUERY_STATUS);
      try
        if (h_service > 0) then
        begin
//--- Get Service status
          if(QueryServiceStatus(h_service, lpServiceStatus)) then
            if(lpServiceStatus.dwCurrentState = SERVICE_RUNNING) then
              result:= true;
        end;
      finally
        CloseServiceHandle(h_service);
      end;
    end;
  finally
    CloseServiceHandle(h_manager);
  end;
end;

//--- Load cgate library and check functions
function LoadCgLib;
begin
  result:= false;
//---set dll directory
  if (SetDllDirectory(PWideChar(ExtractFilePath(Name)))) then
  begin
//--- load lib
    aHandle:= LoadLibrary(PWideChar(Name));
//--- check functions
    if(aHandle <> 0) then
    begin
      @cg_env_open:= GetProcAddress(aHandle, 'cg_env_open');
      if(addr(cg_env_open) <> nil) then
      begin
        @cg_env_close:= GetProcAddress(aHandle, 'cg_env_close');
        if(addr(cg_env_close) <> nil) then
        begin
          @cg_conn_new:= GetProcAddress(aHandle, 'cg_conn_new');
          if(addr(cg_conn_new) <> nil) then
          begin
            @cg_conn_destroy:= GetProcAddress(aHandle, 'cg_conn_destroy');
            if(addr(cg_conn_destroy) <> nil) then
            begin
              @cg_conn_open:= GetProcAddress(aHandle, 'cg_conn_open');
              if(addr(cg_conn_open) <> nil) then
              begin
                @cg_conn_close:= GetProcAddress(aHandle, 'cg_conn_close');
                if(addr(cg_conn_close) <> nil) then
                begin
                  @cg_conn_getstate:= GetProcAddress(aHandle, 'cg_conn_getstate');
                  if(addr(cg_conn_getstate) <> nil) then
                  begin
                    @cg_conn_process:= GetProcAddress(aHandle, 'cg_conn_process');
                     if(addr(cg_conn_process) <> nil) then
                     begin
    @cg_conn_process:= GetProcAddress(aHandle, 'cg_conn_process');
    if(addr(cg_conn_process) <> nil) then
    begin
      @cg_lsn_new:= GetProcAddress(aHandle, 'cg_lsn_new');
      if(addr(cg_lsn_new) <> nil) then
      begin
          @cg_lsn_destroy:= GetProcAddress(aHandle, 'cg_lsn_destroy');
          if(addr(cg_lsn_destroy) <> nil) then
          begin
            @cg_lsn_getstate:= GetProcAddress(aHandle, 'cg_lsn_getstate');
            if(addr(cg_lsn_getstate) <> nil) then
            begin
              @cg_lsn_open:= GetProcAddress(aHandle, 'cg_lsn_open');
              if(addr(cg_lsn_open) <> nil) then
              begin
                @cg_lsn_close:= GetProcAddress(aHandle, 'cg_lsn_close');
                if(addr(cg_lsn_close) <> nil) then
                begin
                   @cg_lsn_getscheme:= GetProcAddress(aHandle, 'cg_lsn_getscheme');
                   if(addr(cg_lsn_getscheme) <> nil) then
                   begin
                     @cg_pub_new:= GetProcAddress(aHandle, 'cg_pub_new');
                     if(addr(cg_pub_new) <> nil) then
                     begin
                        @cg_pub_destroy:= GetProcAddress(aHandle, 'cg_pub_destroy');
                        if(addr(cg_pub_destroy) <> nil) then
                        begin
                           @cg_pub_open:= GetProcAddress(aHandle, 'cg_pub_open');
                           if(addr(cg_pub_open) <> nil) then
                           begin
                             @cg_pub_close:= GetProcAddress(aHandle, 'cg_pub_close');
                             if(addr(cg_pub_close) <> nil) then
                             begin
    @cg_pub_getstate:= GetProcAddress(aHandle, 'cg_pub_getstate');
    if(addr(cg_pub_getstate) <> nil) then
    begin
      @cg_pub_getscheme:= GetProcAddress(aHandle, 'cg_pub_getscheme');
      if(addr(cg_pub_getscheme) <> nil) then
      begin
        @cg_pub_msgnew:= GetProcAddress(aHandle, 'cg_pub_msgnew');
        if(addr(cg_pub_msgnew) <> nil) then
        begin
          @cg_pub_msgfree:= GetProcAddress(aHandle, 'cg_pub_msgfree');
          if(addr(cg_pub_msgfree) <> nil) then
          begin
            @cg_pub_post:= GetProcAddress(aHandle, 'cg_pub_post');
            if(addr(cg_pub_post) <> nil) then
            begin
              @cg_err_getstr:= GetProcAddress(aHandle, 'cg_err_getstr');
              if(addr(cg_err_getstr) <> nil) then
              begin
                @cg_msg_dump:= GetProcAddress(aHandle, 'cg_msg_dump');
                if(addr(cg_msg_dump) <> nil) then
                begin
                  @cg_msg_dump:= GetProcAddress(aHandle, 'cg_msg_dump');
                  if(addr(cg_msg_dump) <> nil) then
                  begin
                    @cg_bcd_get:= GetProcAddress(aHandle, 'cg_bcd_get');
                    if(addr(cg_bcd_get) <> nil) then
                    begin
                      @cg_getstr:= GetProcAddress(aHandle, 'cg_getstr');
                      if(addr(cg_getstr) <> nil) then
                      begin
                        @cg_log_tracestr:= GetProcAddress(aHandle, 'cg_log_tracestr');
                        if(addr(cg_log_tracestr) <> nil) then
                        begin
    @cg_log_debugstr:= GetProcAddress(aHandle, 'cg_log_debugstr');
    if(addr(cg_log_debugstr) <> nil) then
    begin
      @cg_log_infostr:= GetProcAddress(aHandle, 'cg_log_infostr');
      if(addr(cg_log_infostr)<>nil) then
      begin
        @cg_log_errorstr:= GetProcAddress(aHandle, 'cg_log_errorstr');
        if(addr(cg_log_errorstr) <> nil) then
        begin
          @cg_env_getcomp_ver:= GetProcAddress(aHandle, 'cg_env_getcomp_ver');
          if(addr(cg_env_getcomp_ver) <> nil) then
          begin
            @cg_env_getcomp_ver:= GetProcAddress(aHandle, 'cg_env_getcomp_ver');
            if(addr(cg_env_getcomp_ver) <> nil) then
            begin
              @cg_env_register_exithandler:= GetProcAddress(aHandle, 'cg_env_register_exithandler');
              if(addr(cg_env_register_exithandler) <> nil) then result:= true;
            end;
          end;
        end;
      end;
    end;
                        end;
                      end;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
                             end;
                           end;
                        end;
                     end;
                   end;
                 end;
              end;
            end;
          end;
       end;
     end;
                     end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

//--- Get listener name
function GetListenerName;
var
  k: integer;
begin
  result:= input;
  k:= pos('lstnr_', result);
  if (k > 0) then Delete(result, 1, k + length('lstnr_') - 1);
end;

end.
