unit Main;

interface

uses
  Winapi.Windows, System.SysUtils, System.Classes, Vcl.Controls, Vcl.Forms,
  Vcl.Menus, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ImgList, Vcl.ToolWin,
  Vcl.Grids, Vcl.StdActns, System.Actions, Vcl.ActnList, System.IniFiles,
  System.DateUtils, About, Settings, ChildWin, P2_cgate_types, Cgate_core_api,
  Cgate_types, cgate;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    ServerData: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    File2: TMenuItem;
    New2: TMenuItem;
    Open2: TMenuItem;
    Save2: TMenuItem;
    SaveAs2: TMenuItem;
    Print2: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    About1: TMenuItem;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    ActionList1: TActionList;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowTileVertical1: TWindowTileVertical;
    WindowMinimizeAll1: TWindowMinimizeAll;
    WindowArrange1: TWindowArrange;
    Connect1: TMenuItem;
    Disconnect1: TMenuItem;
    CommonControl: TPageControl;
    Forts: TTabSheet;
    FortsControl: TPageControl;
    FortsBillSheet: TTabSheet;
    FortsPosiSheet: TTabSheet;
    N2: TMenuItem;
    InstrumGet: TMenuItem;
    FortsDealsSheet: TTabSheet;
    FortsOrdersSheet: TTabSheet;
    FortsBillGrid: TStringGrid;
    FortsPosGrid: TStringGrid;
    FortsDealsGrid: TStringGrid;
    FortsOrdersGrid: TStringGrid;
    Journal: TTabSheet;
    JournalEdit: TRichEdit;
    FortsMultiDealsSheet: TTabSheet;
    FortsMultiOrdersSheet: TTabSheet;
    FortsMOrdersGrid: TStringGrid;
    FortsMDealsGrid: TStringGrid;
    Timer1: TTimer;
    Splitter1: TSplitter;
    N3: TMenuItem;
    N4: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Exit1Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure ServerDataClick(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure InstrumGetClick(Sender: TObject);
  private
    { Private declarations }
    procedure CreateMDIChild(const Name: string);
    procedure ForceExit(const msg: string);
    procedure FutItemClick(Senger: TObject);
    procedure OptItemClick(Senger: TObject);
    function SaveSettings(sForm: TSetForm): boolean;
    procedure BuildConnections();
    function CheckConnReady(): boolean;
    function DataToStrTime(const aData: tcg_time): string;
//    function BuffToInt64(const buff: array of byte): int64_t;
//    function BuffToDataTime(const buff: array of byte): string;
  public
    { Public declarations }
  end;

const
  Transac = 30;

var
  MainForm: TMainForm;
  appPath: string;
  ITradeInfo: TSymbolsTradeInfo;

implementation

{$R *.dfm}


procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutBox:= TAboutBox.Create(self);
  try
    AboutBox.ShowModal;
  finally
    AboutBox.Free;
  end;
end;


procedure TMainForm.Connect1Click(Sender: TObject);
var
  outSet: TP2Set;
  result: PAnsiChar;
begin
  outSet.lpRegKey:= PAnsiChar('SOFTWARE\Moscow Exchange\SpectraCGate');
  outSet.lpRegValue:= PAnsiChar('InstallDir');
  outSet.lpMachine:= PWideChar('127.0.0.1');
  outSet.lpServName:= PWideChar('SpectraCGate');
  outSet.lpSet:= SetData.outset;
  result:= PlazaConnect(outSet);
  if (string(result) = 'Version OK!') then
  begin
    MainMenu1.Items[0].Items[1].Enabled:= true;
    MainMenu1.Items[1].Items[0].Enabled:= true;
    StatusBar1.Panels.Items[1].Text:= '';
  end else
  begin
    MainMenu1.Items[0].Items[1].Enabled:= false;
    StatusBar1.Panels.Items[1].Text:= ' ';
    Application.MessageBox(PWideChar(string(result)), PWideChar(''), MB_OK or MB_ICONHAND);
  end;
end;

procedure TMainForm.Disconnect1Click(Sender: TObject);
begin
  if (PlazaDisconnect() = true) then
  begin
    MainMenu1.Items[0].Items[1].Enabled:= false;
    MainMenu1.Items[1].Items[0].Enabled:= false;
    StatusBar1.Panels.Items[1].Text:= ' ';
    if (MainMenu1.Items[1].Items[1].count > 0) then
    begin
      MainMenu1.Items[1].Items[1].Clear;
      MainMenu1.Items[1].Items[1].Enabled:= false;
    end;
    if (MainMenu1.Items[1].Items[2].count > 0) then
    begin
      MainMenu1.Items[1].Items[2].Clear;
      MainMenu1.Items[1].Items[2].Enabled:= false;
    end;
    JournalEdit.Lines.SaveToFile(appPath + 'log\Journal.txt');
    JournalEdit.Lines.Clear;
  end else
  begin
    StatusBar1.Panels.Items[1].Text:= '';
    MainMenu1.Items[0].Items[1].Enabled:= true;
    MainMenu1.Items[1].Items[0].Enabled:= true;
  end;
end;

procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
// create a new MDI child window
  Child:= TMDIChild.Create(Application);
  Child.Caption:= Name;
end;


procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close();
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  aData: PSetData;
  iniFile: TIniFile;
  i, j: integer;
  Section: string;
begin
  if (Application.MessageBox(PWideChar('   ?'),
   PWideChar(''), MB_OKCANCEL or MB_ICONQUESTION) = ID_OK) then
  begin
//--- save data to ini file
    iniFile:= TIniFile.Create(appPath + 'p2cgtrader.ini');
    try
      with SetData do
      begin
//---environment
        for i:= 0 to environment.cnt - 1 do
          iniFile.WriteString('environment', environment.Ent_name[i], environment.data[i]);
//--- streams
        for i:= 0 to streams.StrCnt - 1 do
        begin
          iniFile.WriteBool('streams', streams.Strs[i].Name, streams.Strs[i].Checked);       //checked
          iniFile.WriteInteger(streams.Strs[i].Name, 'snonline', streams.Strs[i].snonline);  //snap+online
          iniFile.WriteBool(streams.Strs[i].Name, 'scheme', streams.Strs[i].Scheme);         //scheme
          iniFile.WriteString(streams.Strs[i].Name, 'schemestr', streams.Strs[i].schemeStr); //scheme String
          Section:= iniFile.ReadString(streams.Strs[i].Name, 'tables', '');                  //tables
          if (Section <> '') then
          begin
            for j:= 0 to streams.Strs[i].TblCnt - 1 do
              iniFile.WriteBool(Section, streams.Strs[i].Tables[j].Name,
                                             streams.Strs[i].Tables[j].Checked);
          end;
        end;
//--- options
        iniFile.WriteBool('options', 'protocol', options.Protocol);
        iniFile.WriteInteger('options', 'transactions', options.Transactions);
        iniFile.WriteInteger('options', 'futdepth', options.FutDepth);
        iniFile.WriteInteger('options', 'optdepth', options.OptDepth);
        for i:= 0 to options.EntryCnt - 1 do
          iniFile.WriteString('entr_data', options.Ent_name[i],
                                                        options.Ent_values[i]);
//--- visual do not save
      end;
    finally
      iniFile.Free;
    end;
//--- disconnect from cgate
    if (PlazaDisconnect() = false) then
    begin
      CanClose:= false;
      exit;
    end;
//--- clear memory
    aData:= @SetData;
    aData:= Nil;
    CanClose:= true;
  end else CanClose:= false;
end;

procedure TMainForm.ForceExit;
begin
  Application.MessageBox(PwideChar(msg), PwideChar(''), MB_OK);
  Application.Terminate;
end;


procedure TMainForm.FormCreate(Sender: TObject);
var
  i, j, k, w, textWidth: integer;
  str: string;
  IniFile: TIniFile;
  Strings, SecStr, TblStr, FieldStr: TStringList;
  GrRect: TGridRect;
  logTime: TDateTime;
begin
//--- Reset data
  FillChar(SetData, sizeof(SetData), 0);
//--- Get application path
  appPath:= ExtractFilePath(Application.ExeName);
//--- TODO: licence file insert in to the cgate!!!
//--- Clear richedit
  JournalEdit.Lines.Clear();
//--- Load ini file
  if(FileExists(appPath + 'p2cgtrader.ini')) then
  begin
    IniFile:= TIniFile.Create(appPath + 'p2cgtrader.ini');
    try
//--- Get main section
      if (IniFile.SectionExists('cgate_settings')) then
      begin
        Strings:= TStringList.Create;
        try
          IniFile.ReadSection('cgate_settings', Strings);
          if (Strings.Count > 0) then
          begin
            with SetData do
            begin
//--- read environment
              for i := 0 to Strings.Count - 1 do
              begin
                SecStr:= TStringList.Create;
                try
                  IniFile.ReadSection(Strings[i], SecStr);
                  if (SecStr.Count > 0) then
                  begin
                    if (Strings[i] = 'environment') then
                    begin
                      environment.cnt:= SecStr.Count;
                      SetLength(environment.data, SecStr.Count);
                      SetLength(environment.Ent_name, SecStr.Count);
                      for j:= 0 to SecStr.Count - 1 do
                      begin
                        environment.Ent_name[j]:= SecStr[j];
                        environment.data[j]:= IniFile.ReadString(Strings[i],
                                                                 SecStr[j], '');
                      end;
                    end else
                    if (Strings[i] = 'streams') then
                    begin
                      IniFile.ReadSection(Strings[i], SecStr);
                      if (SecStr.Count > 0) then
                      begin
                        streams.StrCnt:= SecStr.Count;
                        SetLength(Streams.Strs, SecStr.Count);
                        for j:= 0 to SecStr.Count - 1 do
                        begin
                          streams.strs[j].Name:= SecStr[j];
                          streams.Strs[j].Checked:= IniFile.ReadBool(Strings[i],
                                                              SecStr[j], false);
                          streams.Strs[j].Scheme:= IniFile.ReadBool(SecStr[j],
                                                               'scheme', false);
                          streams.Strs[j].schemeStr:= IniFile.ReadString(SecStr[j],
                                                               'schemestr', '');
                          streams.Strs[j].snonline:= IniFile.ReadInteger(SecStr[j],
                                                                 'snonline', 0);
//--- tables
                          TblStr:= TStringList.Create;
                          try
                            str:= IniFile.ReadString(SecStr[j], 'tables', '');
                            IniFile.ReadSection(str, TblStr);
                            if (TblStr.Count > 0) then
                            begin
                              SetLength(streams.Strs[j].Tables, TblStr.Count);
                              streams.Strs[j].TblCnt:= TblStr.Count;
                              for k:= 0 to TblStr.Count - 1 do
                              begin
                                streams.Strs[j].Tables[k].Name:= TblStr[k];
                                streams.Strs[j].Tables[k].Checked:= IniFile.ReadBool(str,
                                                              TblStr[k], false);
//--- tables fields
                                FieldStr:= TStringList.Create;
                                try
                                  IniFile.ReadSection(str + ':' + TblStr[k], FieldStr);
                                  if (FieldStr.Count > 0) then
                                  begin
                                    streams.Strs[j].Tables[k].FielsCnt:= FieldStr.Count;
                                    SetLength(streams.Strs[j].Tables[k].Fields,
                                                                FieldStr.Count);
                                    for w:= 0 to FieldStr.Count - 1 do
                                    begin
                                      streams.Strs[j].Tables[k].Fields[w].Name:= FieldStr[w];
                                      streams.Strs[j].Tables[k].Fields[w].value:=
                                      IniFile.ReadString(str + ':' + TblStr[k], FieldStr[w], '');
                                    end;
                                  end;
                                finally
                                  FieldStr.Free;
                                end;
                              end;
                            end;
                          finally
                            TblStr.Free;
                          end;
                        end;
                      end;
                    end else
                    if (Strings[i] = 'options') then
                    begin
                      IniFile.ReadSection(Strings[i], SecStr);
                      if (SecStr.Count > 0) then
                      begin
                        for j:= 0 to SecStr.Count - 1 do
                        begin
                          case j of
                            0: options.Protocol:= IniFile.ReadBool(Strings[i],
                                                            SecStr[j], false);
                            1: options.Transactions:= IniFile.ReadInteger(Strings[i],
                                                               SecStr[j], -1);
                            2: begin
                                 TblStr:= TStringList.Create;
                                 try
                                   IniFile.ReadSection(SecStr[j], TblStr);
                                   if (TblStr.Count > 0) then
                                   begin
                                     options.EntryCnt:= TblStr.Count;
                                     SetLength(options.Ent_name, TblStr.Count);
                                     SetLength(options.Ent_values, TblStr.Count);
                                     for k:= 0 to TblStr.Count - 1 do
                                     begin
                                       options.Ent_name[k]:= TblStr[k];
                                       options.Ent_values[k]:= IniFile.ReadString(SecStr[j],
                                                                     TblStr[k], '');
                                     end;
                                   end;
                                 finally
                                   TblStr.Free;
                                 end;
                               end;
                            3: options.FutDepth:= IniFile.ReadInteger(Strings[i],
                                                                 SecStr[j], -1);
                            4: options.OptDepth:= IniFile.ReadInteger(Strings[i],
                                                                 SecStr[j], -1);
                          end;
                        end;
                      end;
                    end else
                    if (Strings[i] = 'visual') then
                    begin
                      TblStr:= TStringList.Create;
                      try
                        IniFile.ReadSection('visual', TblStr);
                        if(TblStr.Count > 0) then
                        begin
                          visual.Tblcnt:= TblStr.Count;
                          SetLength(visual.Tables, TblStr.Count);
                          for j:= 0 to TblStr.Count - 1 do
                            visual.Tables[j].Name:= TblStr[j];
                          for j:= 0 to TblStr.Count - 1 do
                          begin
                            SecStr.Clear;
                            IniFile.ReadSection('visual:' + TblStr[j], SecStr);
                            if(SecStr.Count > 0) then
                            begin
                              visual.Tables[j].FielsCnt:= SecStr.Count;
                              SetLength(visual.Tables[j].Fields, SecStr.Count);
                              if (visual.Tables[j].Name = 'part') then
                                FortsBillGrid.ColCount:= SecStr.Count else
                              if (visual.Tables[j].Name = 'position') then
                                FortsPosGrid.ColCount:= SecStr.Count else
                              if (visual.Tables[j].Name = 'user_deal') then
                                FortsDealsGrid.ColCount:= SecStr.Count else
                              if (visual.Tables[j].Name = 'orders_log') then
                                FortsOrdersGrid.ColCount:= SecStr.Count else
                              if (visual.Tables[j].Name = 'user_multileg_deal') then
                                FortsMDealsGrid.ColCount:= SecStr.Count else
                              if (visual.Tables[j].Name = 'multileg_orders_log') then
                                FortsMOrdersGrid.ColCount:= SecStr.Count;
                              for k:= 0 to SecStr.Count - 1 do
                              begin
                                visual.Tables[j].Fields[k].Name:= SecStr[k];
                                if (TblStr[j] = 'part') then
                                with FortsBillGrid do
                                begin
                                  Cells[k, 0]:= IniFile.ReadString('visual:' +
                                                                   TblStr[j],
                                                                   SecStr[k], '');
                                end else
                                if (TblStr[j] = 'position') then
                                with FortsPosGrid do
                                begin
                                  Cells[k, 0]:= IniFile.ReadString('visual:' +
                                                                   TblStr[j],
                                                                   SecStr[k], '');
                                end else
                                if (TblStr[j] = 'user_deal') then
                                with FortsDealsGrid do
                                begin
                                  Cells[k, 0]:= IniFile.ReadString('visual:' +
                                                                   TblStr[j],
                                                                   SecStr[k], '');
                                end else
                                if (TblStr[j] = 'orders_log') then
                                with FortsOrdersGrid do
                                begin
                                  Cells[k, 0]:= IniFile.ReadString('visual:' +
                                                                   TblStr[j],
                                                                   SecStr[k], '');
                                end else
                                if (TblStr[j] = 'user_multileg_deal') then
                                with FortsMDealsGrid do
                                begin
                                  Cells[k, 0]:= IniFile.ReadString('visual:' +
                                                                   TblStr[j],
                                                                   SecStr[k], '');
                                end else
                                if (TblStr[j] = 'multileg_orders_log') then
                                with FortsMOrdersGrid do
                                begin
                                  Cells[k, 0]:= IniFile.ReadString('visual:' +
                                                                   TblStr[j],
                                                                   SecStr[k], '');
                                end;
                              end;
                            end;
                          end;
//--- align grids text
                          for j:= 0 to FortsBillGrid.ColCount - 1 do
                          begin
                            textWidth:= Canvas.TextWidth(FortsBillGrid.Cells[j, 0] + '   ');
                            FortsBillGrid.ColWidths[j] := textWidth;
                          end;
                          for j:= 0 to FortsPosGrid.ColCount - 1 do
                          begin
                            textWidth:= Canvas.TextWidth(FortsPosGrid.Cells[j, 0] + '   ');
                            FortsPosGrid.ColWidths[j] := textWidth;
                          end;
                          for j:= 0 to FortsDealsGrid.ColCount - 1 do
                          begin
                            textWidth:= Canvas.TextWidth(FortsDealsGrid.Cells[j, 0] + '   ');
                            FortsDealsGrid.ColWidths[j] := textWidth;
                          end;
                          for j:= 0 to FortsOrdersGrid.ColCount - 1 do
                          begin
                            textWidth:= Canvas.TextWidth(FortsOrdersGrid.Cells[j, 0] + '   ');
                            FortsOrdersGrid.ColWidths[j] := textWidth;
                          end;
                          for j:= 0 to FortsMDealsGrid.ColCount - 1 do
                          begin
                            textWidth:= Canvas.TextWidth(FortsMDealsGrid.Cells[j, 0] + '   ');
                            FortsMDealsGrid.ColWidths[j] := textWidth;
                          end;
                          for j:= 0 to FortsMOrdersGrid.ColCount - 1 do
                          begin
                            textWidth:= Canvas.TextWidth(FortsMOrdersGrid.Cells[j, 0] + '   ');
                            FortsMOrdersGrid.ColWidths[j] := textWidth;
                          end;
//--- renove focus
                          with GrRect do
                          begin
                            Left := -1;
                            Top := -1;
                            Right := -1;
                            Bottom := -1;
                          end;
                          FortsBillGrid.Selection:= GrRect;
                          FortsPosGrid.Selection:= GrRect;
                          FortsDealsGrid.Selection:= GrRect;
                          FortsOrdersGrid.Selection:= GrRect;
                          FortsMDealsGrid.Selection:= GrRect;
                          FortsMOrdersGrid.Selection:= GrRect;
                        end;
                      finally
                        TblStr.Free;
                      end;
                    end;
                  end;
                finally
                  SecStr.Free;
                end;
              end;
            end;
          end else
            ForceExit(' "cgate_settings"   p2cgtrader.ini .   .');
        finally
          Strings.Free;
        end;
      end else
        ForceExit('   "cgate_settings"   p2cgtrader.ini.   .');
    finally
      IniFile.Free;
    end;
  end;
//--- build enviroiment, connection ans listener settings
  BuildConnections();
  logTime:= Now;
  DateTimeToString(str, 'dd.mm.yyyy hh:mm:ss', logTime);
  JournalEdit.Lines.Add(str + ' --> P2 Cgate trader started...');
  Timer1.Enabled:= true;
end;

procedure TMainForm.FutItemClick;
var
  i: integer;
 // ChWin: TMDIChild;
  aName: string;
begin
//--- TODO: Get name for child window

//--- Set instrument and open child window

  if (MDIChildCount > 0) then
  begin
    for i:= 0 to MDIChildCount - 1 do
    begin
     // ChWin:= MDIChild[i];
    end;
  end else
  begin
    CreateMDIChild(aName);
  end;
end;

procedure TMainForm.OptItemClick;
var
  i: integer;
 // ChWin: TMDIChild;
  aName: string;
begin
//--- TODO: Get name for child window

//--- Set instrument and open child window

  if (MDIChildCount > 0) then
  begin
    for i:= 0 to MDIChildCount - 1 do
    begin
     // ChWin:= MDIChild[i];
    end;
  end else
  begin
    CreateMDIChild(aName);
  end;
end;


procedure TMainForm.InstrumGetClick(Sender: TObject);
var
  Res: integer;
  Data: PSymbolsTradeInfo;
  Item: TMenuItem;
  i: integer;
  logTime: TDateTime;
  str: string;
begin
  GetMem(Data, ONE_MEG);
  try
  Res:= GetInstruments(Pointer(Data));
  if (Res = 0) then
  begin
    if(MainMenu1.Items[1].Items[1].Count > 0) then
      MainMenu1.Items[1].Items[1].Clear;
    if(MainMenu1.Items[1].Items[2].Count > 0) then
      MainMenu1.Items[1].Items[2].Clear;
//--- Session information
    logTime:= Now;
    DateTimeToString(str, 'dd.mm.yyyy hh:mm:ss', logTime);
    JournalEdit.Lines.Add(str + ' --> Session information:');
    JournalEdit.Lines.Add(str + ' --> sess_id: ' + IntToStr(Data^.CurSess.sess_id));
    JournalEdit.Lines.Add(str + ' --> begin: ' + DataToStrTime(Data^.CurSess.sess_begin));
    { if (aData^.CurSess.sess_id > -1) then
     begin
  //--- Print session
       logTime:= Now;
       DateTimeToString(str, 'dd.mm.yyyy hh:mm:ss', logTime);
       JournalEdit.Lines.Add(str + ' --> Session information:');
       JournalEdit.Lines.Add(str + ' --> sess_id: ' +
                 IntToStr(BuffToInt64(ITradeInfo.Session.Elements[3].Data.Buff)));
       JournalEdit.Lines.Add(str + ' --> begin: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[4].Data.Buff));
       JournalEdit.Lines.Add(str + ' --> end: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[5].Data.Buff));
       JournalEdit.Lines.Add(str + ' --> state: ' +
                 IntToStr(BuffToInt64(ITradeInfo.Session.Elements[6].Data.Buff)));
       JournalEdit.Lines.Add(str + ' --> opt_sess_id: ' +
                 IntToStr(BuffToInt64(ITradeInfo.Session.Elements[7].Data.Buff)));
       JournalEdit.Lines.Add(str + ' --> inter_cl_begin: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[8].Data.Buff));
       JournalEdit.Lines.Add(str + ' --> inter_cl_end: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[9].Data.Buff));
       JournalEdit.Lines.Add(str + ' --> inter_cl_state: ' +
                 IntToStr(BuffToInt64(ITradeInfo.Session.Elements[10].Data.Buff)));
       JournalEdit.Lines.Add(str + ' --> eve_on: ' +
                 IntToStr(BuffToInt64(ITradeInfo.Session.Elements[11].Data.Buff)));
       JournalEdit.Lines.Add(str + ' --> eve_begin: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[12].Data.Buff));
       JournalEdit.Lines.Add(str + ' --> eve_end: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[13].Data.Buff));
       JournalEdit.Lines.Add(str + ' --> mon_on: ' +
                 IntToStr(BuffToInt64(ITradeInfo.Session.Elements[14].Data.Buff)));
       JournalEdit.Lines.Add(str + ' --> mon_begin: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[15].Data.Buff));
       JournalEdit.Lines.Add(str + ' --> mon_end: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[16].Data.Buff));
       JournalEdit.Lines.Add(str + ' --> pos_transfer_begin: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[17].Data.Buff));
       JournalEdit.Lines.Add(str + ' --> pos_transfer_end: ' +
                 BuffToDataTime(ITradeInfo.Session.Elements[18].Data.Buff));
     end;}
//--- futures
    if (Length(Data^.Fut.smbls) > 0) then
    begin
      SetLength(ITradeInfo.Fut.smbls, Length(Data^.Fut.smbls));
      for i:= 0 to length(ITradeInfo.Fut.smbls) - 1 do
      begin
        ITradeInfo.Fut.smbls[i].ResBook:= Data^.Fut.smbls[i].ResBook;
        ITradeInfo.Fut.smbls[i].isin_id:= Data^.Fut.smbls[i].isin_id;
        ITradeInfo.Fut.smbls[i].isin:= Data^.Fut.smbls[i].isin;
        ITradeInfo.Fut.smbls[i].sh_isin:= Data^.Fut.smbls[i].sh_isin;
        ITradeInfo.Fut.smbls[i].name:= Data^.Fut.smbls[i].name;
        ITradeInfo.Fut.smbls[i].StrNum:= Data^.Fut.smbls[i].StrNum;
        ITradeInfo.Fut.smbls[i].TblNum:= Data^.Fut.smbls[i].TblNum;
        Item:= TMenuItem.Create(MainMenu1.Items[1].Items[1]);
        Item.Caption:= ITradeInfo.Fut.smbls[i].isin;
        Item.Hint:= ITradeInfo.Fut.smbls[i].name;
        Item.OnClick:= FutItemClick;
        Item.AutoCheck:= true;
        MainMenu1.Items[1].Items[1].Add(Item);
      end;
      MainMenu1.Items[1].Items[1].Enabled:= true;
    end;
//--- options
    if (Length(Data^.Opt.smbls) > 0) then
    begin
      SetLength(ITradeInfo.Opt.smbls, Length(Data^.Opt.smbls));
      for i:= 0 to length(ITradeInfo.Opt.smbls) - 1 do
      begin
        ITradeInfo.Opt.smbls[i].ResBook:= Data^.Opt.smbls[i].ResBook;
        ITradeInfo.Opt.smbls[i].isin_id:= Data^.Opt.smbls[i].isin_id;
        ITradeInfo.Opt.smbls[i].isin:= Data^.Opt.smbls[i].isin;
        ITradeInfo.Opt.smbls[i].sh_isin:= Data^.Opt.smbls[i].sh_isin;
        ITradeInfo.Opt.smbls[i].name:= Data^.Opt.smbls[i].name;
        ITradeInfo.Opt.smbls[i].StrNum:= Data^.Opt.smbls[i].StrNum;
        ITradeInfo.Opt.smbls[i].TblNum:= Data^.Opt.smbls[i].TblNum;
        Item:= TMenuItem.Create(MainMenu1.Items[1].Items[2]);
        Item.Caption:= ITradeInfo.Opt.smbls[i].isin;
        Item.Hint:= ITradeInfo.Opt.smbls[i].name;
        Item.OnClick:= OptItemClick;
        Item.AutoCheck:= true;
        MainMenu1.Items[1].Items[2].Add(Item);
      end;
      MainMenu1.Items[1].Items[2].Enabled:= true;
    end;
  end else
    Application.MessageBox(PWideChar('  .    .'),
                           PWideChar(''), MB_OK or MB_ICONINFORMATION);
  finally
    FreeMem(Data);
  end;
end;

procedure TMainForm.ServerDataClick(Sender: TObject);
var
  i, j: integer;
  aNode, ChildNode: TTreeNode;
  pData: PNodeData;
  curEdit: TEdit;
begin
  SetForm:= TSetForm.Create(self);
  try
    with SetForm.TreeView1 do
    begin
      Items.BeginUpdate;
      try
//--- Set streams and tables settings
        for i:= 0 to SetData.streams.StrCnt - 1 do
        begin
          New(pData);
          pData^.scheme:= SetData.Streams.Strs[i].Scheme;
          pData^.schemeStr:= SetData.Streams.Strs[i].schemeStr;
          pData^.SnOnline:= SetData.Streams.Strs[i].snonline;
          aNode:= Items.AddObject(nil, SetData.Streams.Strs[i].Name, pData);
          if (SetData.Streams.Strs[i].Checked) then
          begin
            aNode.ImageIndex:= 1;
            aNode.SelectedIndex:= 1;
            if (aNode.Text = 'FORTS_FUTAGGRXX_REPL')
              then SetForm.RadioGroup1.Enabled:= true;
            if (aNode.Text = 'FORTS_OPTAGGRXX_REPL')
              then SetForm.RadioGroup2.Enabled:= true;
          end else
          begin
            aNode.ImageIndex:= 0;
            aNode.SelectedIndex:= 0;
            if (aNode.Text = 'FORTS_FUTAGGRXX_REPL')
              then SetForm.RadioGroup1.Enabled:= false;
            if (aNode.Text = 'FORTS_OPTAGGRXX_REPL')
              then SetForm.RadioGroup2.Enabled:= false;
          end;
//--- Load child nodes
          for j:= 0 to SetData.Streams.Strs[i].TblCnt - 1 do
          begin
            ChildNode:= Items.AddChild(aNode, SetData.Streams.Strs[i].Tables[j].Name);
            if (SetData.Streams.Strs[i].Tables[j].Checked) then
            begin
              ChildNode.ImageIndex:= 1;
              ChildNode.SelectedIndex:= 1;
            end else
            begin
              ChildNode.ImageIndex:= 0;
              ChildNode.SelectedIndex:= 0;
            end;
          end;
        end;
        Items[0].Selected:= true;
      finally
        Items.EndUpdate;
      end;
    end;
//--- Set environment settings
    for i:= 0 to SetData.environment.cnt - 1 do
    begin
      curEdit:= SetForm.FindComponent(SetData.environment.Ent_name[i]) as TEdit;
      if (curEdit <> Nil) then
        curEdit.Text:= SetData.environment.data[i];
    end;
//--- Set options settings
    SetForm.RadioGroup1.ItemIndex:= SetData.options.FutDepth;
    SetForm.RadioGroup2.ItemIndex:= SetData.options.OptDepth;
    SetForm.SpinEdit1.Value:= SetData.options.Transactions;
    for i:= 0 to SetData.options.EntryCnt - 1 do
    begin
      curEdit:= SetForm.FindComponent(SetData.options.Ent_name[i]) as TEdit;
      if (curEdit <> Nil) then
        curEdit.Text:= SetData.options.Ent_values[i];
    end;
    SetForm.CheckBox1.Checked:= SetData.options.Protocol;
    SetForm.CheckBox1.OnClick(self);
//--- Show form
    SetForm.ShowModal;
    if(SetForm.ModalResult = mrOk) then
    begin
//--- Save data
      if (not SaveSettings(SetForm)) then
      begin
        Application.MessageBox(PWideChar('  !'),
                               PWideChar(' '),
                               MB_OK or MB_ICONERROR);
      end;
    end else
    begin
     if (CheckConnReady()) then MainMenu1.Items[0].Items[0].Enabled:= true else
       MainMenu1.Items[0].Items[0].Enabled:= false;
    end;
//--- free treeview memory
    for i:= 0 to SetForm.TreeView1.Items.Count - 1 do
    begin
      aNode:= SetForm.TreeView1.Items[i];
      if (aNode.Count > 0) then
        if (aNode.Data <> Nil) then Dispose(aNode.Data);
    end;
  finally
    SetForm.Free;
  end;
end;


procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:= false;
  if (SetData.GoConnect) then MainMenu1.Items[0].Items[0].Enabled:= true else
    ServerDataClick(Self);
end;


function TMainForm.SaveSettings;
var
  i,j, k, w: integer;
  node, ChNode: TTreeNode;
  pData: PNodeData;
  CurEdit: TEdit;
begin
  with SetData do
  begin
    with sForm.TreeView1 do
    begin
      for i:= 0 to Items.Count - 1 do
      begin
        node:= Items[i];
        if (node.Count > 0) then
        begin
//--- find stream
          for j:= 0 to streams.StrCnt - 1 do
          begin
            if (streams.Strs[j].Name = node.Text) then
            begin
              pData:= Node.Data;
              if (node.ImageIndex = 0) then streams.Strs[j].Checked:= false else
                streams.Strs[j].Checked:= true;
              streams.Strs[j].Scheme:= pData^.scheme;
              streams.Strs[j].schemeStr:= pData^.schemeStr;
              streams.Strs[j].snonline:= pData^.SnOnline;
//--- tables
              for k:= 0 to node.Count - 1 do
              begin
                ChNode:= node.Item[k];
                for w:= 0 to streams.Strs[j].TblCnt - 1 do
                begin
                  if (ChNode.Text = streams.Strs[j].Tables[w].Name) then
                  begin
                    if (ChNode.ImageIndex = 0) then
                      streams.Strs[j].Tables[w].Checked:= false else
                    streams.Strs[j].Tables[w].Checked:= true;
                    break;
                  end;
                end;
              end;
              break;
            end;
          end;
        end;
      end;
    end;
//--- environment
    for i:= 0 to environment.cnt - 1 do
    begin
      curEdit:= Sform.FindComponent(environment.Ent_name[i]) as TEdit;
      if (CurEdit <> nil) then
        environment.data[i]:= CurEdit.Text;
    end;
//--- options
    options.Transactions:= sForm.SpinEdit1.Value;
    options.Protocol:= sForm.CheckBox1.Checked;
    options.FutDepth:= sForm.RadioGroup1.ItemIndex;
    options.OptDepth:= sForm.RadioGroup2.ItemIndex;
    for i:= 0 to options.EntryCnt - 1 do
    begin
      curEdit:= Sform.FindComponent(options.Ent_name[i]) as TEdit;
      if (CurEdit <> nil) then
        options.Ent_values[i]:= CurEdit.Text;
    end;
//--- build connections
    BuildConnections();
  end;
  result:= true;
end;

procedure TMainForm.BuildConnections();
var
  i, j, l_Cnt: integer;
  str: string;
begin
  with SetData do
  begin
//--- transactions
    outset.Transactions:= options.Transactions * Transac;
//---Build environment string
    outset.envStr:= '';
    if (environment.cnt >= 5) then
    begin
      for i:= 0 to environment.cnt - 1 do
      begin
        case i of
          0: if (environment.data[i] <> '') then
               outset.envStr:= outset.envStr + 'ini=' + environment.data[i] + ';';
          1: if (environment.data[i] <> '') then
               outset.envStr:= outset.envStr + 'subsystems=' + environment.data[i] + ';';
          2: if (environment.data[i] <> '') then
               outset.envStr:= outset.envStr + 'log=' + environment.data[i] + ';';
          3: if (environment.data[i] <> '') then
               outset.envStr:= outset.envStr + 'minloglevel=' + environment.data[i] + ';';
          4: if (environment.data[i] <> '') then
               outset.envStr:= outset.envStr + 'key=' + environment.data[i];
        end;
      end;
    end;
//--- Connection
    outset.ConnStr:= '';
    if (options.EntryCnt >= 9) then
    begin
      for i:= 0 to options.EntryCnt - 1 do
      begin
        case i of
          0: outset.ConnStr:= options.Ent_values[i] + '://';
          1: outset.ConnStr:= outset.ConnStr + options.Ent_values[i] + ':';
          2: outset.ConnStr:= outset.ConnStr + options.Ent_values[i] + ';';
          3: begin
               outset.ConnStr:= outset.ConnStr + 'app_name=' + options.Ent_values[i] + ';';
               Str:= options.Ent_values[i];
             end;
          4: if (options.Ent_values[i] <> '') then
               outset.ConnStr:= outset.ConnStr + 'local_pas=' + options.Ent_values[i] + ';';
          5: outset.ConnStr:= outset.ConnStr + 'timeout=' + options.Ent_values[i] + ';';
          6: if (options.Protocol) then
               outset.ConnStr:= outset.ConnStr + 'local_timeout=' + options.Ent_values[i] + ';';
          7: outset.ConnStr:= outset.ConnStr + 'name=' + options.Ent_values[i] +
                                                                      str + ';';
          8: if (options.Protocol) then
               outset.ConnStr:= outset.ConnStr + 'lrpcq_buf=' + options.Ent_values[i];
        end;
      end;
    end;
//--- Delete ","
    if ((outset.ConnStr[length(outset.ConnStr)] = ';')) then
      Delete(outset.ConnStr, length(outset.ConnStr), 1);
//--- build listeners
    l_Cnt:= 0;
    for i:= 0 to streams.StrCnt - 1 do
    begin
      if (streams.Strs[i].Checked) then
      begin
        inc(l_Cnt);
        SetLength(outset.ListnrsNew, l_Cnt);
        SetLength(outset.LOpenParam, l_Cnt);
        if(streams.Strs[i].Name = 'FORTS_FUTAGGRXX_REPL') then
        begin
          j:= Pos('XX', streams.Strs[i].Name);
          if (j > 0) then
          begin
            str:= streams.Strs[i].Name;
            Delete(Str, j, 2);
            case options.FutDepth of
              0: Insert('5', str, j);
              1: Insert('20', str, j);
              2: Insert('50', str, j);
            end;
            outset.ListnrsNew[l_cnt - 1]:= 'p2repl://' + str + ';tables=';
          end;
        end else
        if(streams.Strs[i].Name = 'FORTS_OPTAGGRXX_REPL') then
        begin
          j:= Pos('XX', streams.Strs[i].Name);
          if (j > 0) then
          begin
            str:= streams.Strs[i].Name;
            Delete(Str, j, 2);
            case options.OptDepth of
              0: Insert('5', str, j);
              1: Insert('20', str, j);
              2: Insert('50', str, j);
            end;
            outset.ListnrsNew[l_cnt - 1]:= 'p2repl://' + str + ';tables=';
          end;
        end else
        begin
          outset.ListnrsNew[l_cnt - 1]:= 'p2repl://' + streams.Strs[i].Name + ';tables=';
          str:= streams.Strs[i].Name;
        end;
//--- tables
        for j:= 0 to streams.Strs[i].TblCnt - 1 do
          if (streams.Strs[i].Tables[j].Checked) then
            outset.ListnrsNew[l_cnt - 1]:= outset.ListnrsNew[l_cnt - 1] +
                                           streams.Strs[i].Tables[j].Name + ',';

//--- Delete ","
        if ((outset.ListnrsNew[l_cnt - 1][length(outset.ListnrsNew[l_cnt - 1])] = ',')) then
              Delete(outset.ListnrsNew[l_cnt - 1], length(outset.ListnrsNew[l_cnt - 1]), 1);
//--- scheme
        if (streams.Strs[i].Scheme) then
          outset.ListnrsNew[l_cnt - 1]:= outset.ListnrsNew[l_cnt - 1] + ';sheme=' +
                                                      streams.Strs[i].SchemeStr;
//--- name
        outset.ListnrsNew[l_cnt - 1]:= outset.ListnrsNew[l_cnt - 1] + ';name=lstnr_' +
                                                                           str;
//--- mode
        case streams.Strs[i].Snonline of
          0: outset.LOpenParam[l_cnt - 1]:= 'mode=snapshot;';
          1: outset.LOpenParam[l_cnt - 1]:= 'mode=online;';
          2: outset.LOpenParam[l_cnt - 1]:= 'mode=snapshot+online;';
        end;
//--- lifenum
        outset.LOpenParam[l_cnt - 1]:= outset.LOpenParam[l_cnt - 1] + 'lifenum=0'
      end;
    end;
    outset.LstnrCnt:= l_Cnt;
  end;
//--- Check to connect ready
  if (CheckConnReady()) then MainMenu1.Items[0].Items[0].Enabled:= true else
    MainMenu1.Items[0].Items[0].Enabled:= false;
end;

function TMainForm.CheckConnReady;
begin
  if (SetData.outset.envStr <> '') then
  begin
    if (SetData.outset.LstnrCnt > 0) then
    begin
      SetData.GoConnect:= true;
      result:= true;
    end else
    begin
      SetData.GoConnect:= false;
      result:= false;
    end;
  end else
  begin
    SetData.GoConnect:= false;
    Result:= false;
  end;
end;

//--- buffer to int64
{function TMainForm.BuffToInt64;
var
  i: integer;
begin
  if (sizeof(buff) > 8) then
  begin
    result:= -1;
    exit;
  end;
  result:= 0;
  for i := 0 to length(buff) - 1 do
    result:= result + (Buff[i] shl (i*8));
end; }

//--- buffer to datetime string
function TMainForm.DataToStrTime;
var
  s: string;
begin
  result:= '';
  s:= IntToStr(aData.day);
  if (length(s) = 1) then s:= '0' + s;
  result:= result + s + '.';
  s:= IntToStr(aData.month);
  if (length(s) = 1) then s:= '0' + s;
  result:= result + s + '.';
  result:= result + IntToStr(aData.year) + ' ';
  s:= IntToStr(aData.hour);
  if (length(s) = 1) then s:= '0' + s;
  result:= result + s + ':';
  s:= IntToStr(aData.minute);
  if (length(s) = 1) then s:= '0' + s;
  result:= result + s + ':';
  s:= IntToStr(aData.second);
  if (length(s) = 1) then s:= '0' + s;
  result:= result + s + '.' + IntToStr(aData.msec);;
end;

end.
